{  ////////////////////////////////////////////////////////////////////////////
  ////////////////////////// COMPILER DETECTION //////////////////////////////
 ////////////////////////////////////////////////////////////////////////////  }

//Needed Delphi 4 or later
{$IFDEF VER80}{$DEFINE OLD}{$ENDIF}        //Delphi 1
{$IFDEF VER90}{$DEFINE OLD}{$ENDIF}        //Delphi 2
{$IFDEF VER100}{$DEFINE OLD}{$ENDIF}       //Delphi 3
{$IFDEF VER110}{$DEFINE DELPHI}{$ENDIF}    //??
{$IFDEF VER120}{$DEFINE DELPHI}{$ENDIF}    //Delphi 4
{$IFDEF VER130}{$DEFINE DELPHI}{$ENDIF}    //Delphi 5
{$IFDEF VER140}{$DEFINE DELPHI}{$ENDIF}    //Delphi 6
{$IFDEF VER150}{$DEFINE DELPHI}{$ENDIF}    //Delphi 7
{$IFDEF VER160}{$DEFINE DELPHI}{$ENDIF}    //Delphi 8
{$IFDEF VER170}{$DEFINE DELPHI}{$ENDIF}    //Delphi 2005

//Needed FPC 2.0.0 or later.
{$IFDEF FPC}
  {$IFDEF VER1_0}{$DEFINE OLD}{$ENDIF}     //FPC 1.0.x
  {$IFDEF VER1}{$DEFINE OLD}{$ENDIF}       //FPC 1.x.x
{$ENDIF}

{  ////////////////////////////////////////////////////////////////////////////
  /////////////////////////// COMPILER TOO OLD? //////////////////////////////
 ////////////////////////////////////////////////////////////////////////////  }

{$IFDEF OLD}
  {$FATAL Your compiler is too old! Please use at least FPC 2.0.0 or Delphi 4. }
{$ENDIF}

{  ////////////////////////////////////////////////////////////////////////////
  ////////////////////// OPERATING SYSTEM DETECTION //////////////////////////
 ////////////////////////////////////////////////////////////////////////////  }

{$IFDEF DELPHI}{$DEFINE WINDOWS}{$ENDIF}
{$IFDEF FPC}{$IFDEF WIN32}{$DEFINE WINDOWS}{$ENDIF}{$ENDIF}

{  ////////////////////////////////////////////////////////////////////////////
  /////////////////////////// COMPILER SPECIFIC //////////////////////////////
 ////////////////////////////////////////////////////////////////////////////  }

{$IFDEF DEBUG}{$D+,L+,Q+,Y+,R+,S+,M+,I+}
{$ELSE}{$D-,L-,Q-,Y-,R-,S-,M-,I-}
{$ENDIF}

{$IFDEF DELPHI}
  {$DEFINE PREALOCATE}
  {$P-,V-,H+,B-,X+,J-}
{$ENDIF}

{$IFDEF FPC}
  {$SMARTLINK ON}
  {$MODE DELPHI}
  {$IFDEF WINDOWS}{$DEFINE PREALOCATE}{$ENDIF}
  {$P-,V-,H+,B-,X+,J-}
{$ENDIF}
